-- 每日任务&&周常任务
checkRequire("Lua_TaskActiveItem");
checkRequire("Lua_TaskRewardItem");
Lua_DailyTaskPanel = class("Lua_DailyTaskPanel", Lua_DisplayObject)
function Lua_DailyTaskPanel:ctor(p)
	self:superCall("ctor", p, "DailyTaskPanel_skin");
end

function Lua_DailyTaskPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.activeProgressBar:createSlider("task_altas", "ui_rcrw_progress_001_m", -28, 0);
	self.activeProgressBar:setMouseEnable(false);
	self.activeProgressBar:setValue(0);

	self.rewardList = Lua_DragList.new(self.content, 625, 790, Lua_AxisDefine.Vertical);
	self.rewardList.tweenId = 2023;
	self.rewardList:setListCell(Lua_TaskRewardItem, 625, 128, 1);
	self.rewardList:setCellSpacing(0, 5);
	self.rewardList:setRectPivot(1);
	self.rewardList:setLocation(0, 306, 0);
end

function Lua_DailyTaskPanel:setPanelType(panelParam)
	self.showPanelType = panelParam;
	self:setActivePointReward();
	self:setProcessMaxValue();
end

-- 设置活跃度抵达某阶段后的奖励item
function Lua_DailyTaskPanel:setActivePointReward()
	local activePointList = DataCenter.taskUtil:getActivePointIndexesByType(self.showPanelType);
	local count = #activePointList;
	local startPosX = self.activeProgressBar.posX - self.activeProgressBar.width / 2;
	local deltaPosX = self.activeProgressBar.width / count;
	local curPosX;
	local rewardVo;
	self.activePointRewardArr = Array();
	for i = 1, count do
		curPosX = startPosX + deltaPosX * i;
		rewardVo = Lua_TaskActiveItem.new(self.content);
		rewardVo:setLocation(curPosX, 380, 0);
		rewardVo:setData(activePointList[i]);
		rewardVo:setLastAndPosX(i == count, curPosX);

		self.activePointRewardArr:add(rewardVo);
	end
end

-- 设置进度条的最大数值
function Lua_DailyTaskPanel:setProcessMaxValue()
	local valueList = DataCenter.taskUtil:getTargetActivePointByType(self.showPanelType);
	local maxValue = valueList[ #valueList ];
	self.activeProgressBar:setMaxValue(maxValue);
end

-- 更新
function Lua_DailyTaskPanel:updateData()
	-- 活跃度变化
	self:updateActivePointReward();

	-- 任务列表
	local dataArr = DataCenter.taskUtil:getTaskInfoIndexesByType(self.showPanelType);
	self.rewardList:setArrayData(dataArr);
end

-- 更新活跃度抵达某阶段的奖励
function Lua_DailyTaskPanel:updateActivePointReward()
	local taskInfo = DataCenter.taskData:getTaskInfoByType(self.showPanelType);
	self.curActiveNumTxt.text = taskInfo.point;
	for i = 1, self.activePointRewardArr:getSize() do
		self.activePointRewardArr[i]:updateRewardState();
	end

	-- 当前进度条变化的目标值
	self.curTargetValue = DataCenter.taskUtil:getCurProcessValue(self.showPanelType, taskInfo.point);
	local enableChange = DataCenter.taskData:enableChangingProcess(); -- 进度条是否需要动态渐进
	if enableChange ~= true then
		DataCenter.taskData:setDailyTaskPanelCurProcessValue(self.curTargetValue);
		self.activeProgressBar:setValue(self.curTargetValue);
	else
		self.preProcessValue = self.preProcessValue or DataCenter.taskData:getPreActivePoint();
		self:startUpdateProcessValue();
	end
end

function Lua_DailyTaskPanel:startUpdateProcessValue()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_DailyTaskPanel", 0.05, self, self.updateProcessValue);
	end
end

function Lua_DailyTaskPanel:updateProcessValue()
	self.preProcessValue = self.preProcessValue + 1;
	
	if self.preProcessValue >= self.curTargetValue then
		 self:endUpdateProcessValue();
		 self.activeProgressBar:setValue(self.curTargetValue);
	else
		self.activeProgressBar:setValue(self.preProcessValue);
	end
end

function Lua_DailyTaskPanel:endUpdateProcessValue()
	if self.countDown == true then
		self.countDown = false;
		self.preProcessValue = nil;
		Lua_CommonUtil.removeTimer(self, self.updateProcessValue);

		DataCenter.taskData:setDailyTaskPanelCurProcessValue(self.curTargetValue);
		-- 进度条动态渐进开关关闭
		DataCenter.taskData:clearPreActivePoint();
	end
end

function Lua_DailyTaskPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	if self.activePointRewardArr ~= nil then
		self.activePointRewardArr:dispose();
		self.activePointRewardArr = nil;
	end

	-- Lua_CommonUtil.removeTimer(self, self.updateProcessValue);
	self:endUpdateProcessValue();

	self:superCall("dispose");
end