-- 活跃度奖励弹框
Lua_TaskActiveRewardWindow = class("Lua_TaskActiveRewardWindow", Lua_Window)
function Lua_TaskActiveRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TaskActiveRewardWindow";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0;
end

function Lua_TaskActiveRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_009", 0, 0, 0, 0);

	self.rewardList = Lua_DragList.new(self.content, 200, 68, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ActiveRewardItem, 68, 68, 1);
	self.rewardList.canDrag = false;
end

function Lua_TaskActiveRewardWindow:showWin(data)
	local posX = data.isLast and 220 or data.rewardPosX;
	LuaUtil.setObjPos(self.content, posX, 456, 0);
	self.winBg:SetDimensions(68 * #data.reward + 30, 98);
	self.rewardList:setArrayData(data.reward);
	self.rewardList:setContentRect(68 * #data.reward, 68);
end

function Lua_TaskActiveRewardWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ActiveRewardItem = class("Lua_ActiveRewardItem", Lua_ListCell);
function Lua_ActiveRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ActiveRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);
	self.itemIcon:setScale(0.54, 0.54);
end

function Lua_ActiveRewardItem:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data[1], data[2]);
	self.itemIcon:setData(tvo);
end

function Lua_ActiveRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end