-- 日常奖励弹框
Lua_TaskRewardTipWindow = class("Lua_TaskRewardTipWindow", Lua_Window)
function Lua_TaskRewardTipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TaskRewardTipWindow";
	self.skinName = "TaskRewardTipWindow_skin";
	self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
	self.isFullSizeWin = true;
end

function Lua_TaskRewardTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg:addClickFuntion(self, self.jumpWindow);
end

function Lua_TaskRewardTipWindow:showWin(param)
	self:superCall("showWin", param);

	local info = DataCenter.taskUtil:getTaskInfoById(param.id);
	self.type = info.mainType;

	self.completeTxt.text = param.desc;
	if info.mainType == Lua_TaskData.dailyTask then
		self.explainTxt:setLangValue(202805);
	elseif info.mainType == Lua_TaskData.weeklyTask then
		self.explainTxt:setLangValue(202806);
	else
		self.explainTxt:setLangValue(202807);
	end
	self:updateShowData();
end

function Lua_TaskRewardTipWindow:updateShowData()
	Lua_CommonUtil.delayCall(1, self, self.onCountDown);
end

function Lua_TaskRewardTipWindow:onCountDown()
	self:hide();
	DataCenter.taskData:showPopupData();
end

function Lua_TaskRewardTipWindow:jumpWindow(go)
	Lua_WindowUtil.openWin("Lua_TaskBaseWindow", Lua_WinParam.ACTION_OPEN, self.type);
	self:onCountDown();
end

function Lua_TaskRewardTipWindow:dispose()
	self:superCall("dispose");
end