Lua_UnlockPrimaryWarWindow = class("Lua_UnlockPrimaryWarWindow", Lua_TipsBaseWindow)
function Lua_UnlockPrimaryWarWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_UnlockPrimaryWarWindow";
end

function Lua_UnlockPrimaryWarWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.contentTxt = UICreate.createLabel(self.content, "", 0, 19, 575, 40, 26);
	self.contentTxt.name = "contentTxt";
	self.contentTxt.alignmentValue = 4;
	-- self.contentTxt.horizontalOverflowValue = 1;
	self.contentTxt.verticalOverflowValue = 1;
	self.contentTxt.colorStr = Lua_ColorDefine.transColorStr("726763");
end

function Lua_UnlockPrimaryWarWindow:showWin(param)
	self:superCall("showWin", param);

	local desStr;
	if param == Lua_TaskData.primaryWarStyle then -- 初级战令
		local lockItem = DataCenter.taskData.lockRewardTVo;
		self.contentTxt.text = LanUtil.formateStr(202825, spliceIconStrById(lockItem.id), lockItem.count);
	else -- 高级战令
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.taskData.rechargeId);
		self.contentTxt.text = LanUtil.formateStr(202826, rechargeInfo.money);
	end
end

function Lua_UnlockPrimaryWarWindow:onSureClick(go)
	if self.showData == Lua_TaskData.primaryWarStyle then
		local lockItem = DataCenter.taskData.lockRewardTVo;
		local hasCount = DataCenter.packData:getItemCountById(lockItem.id);
		if hasCount < lockItem.count then
			DataCenter.packUtil:openPathWindow(lockItem);
		else
			Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarUnlockPrimary();
		end
	end
	self:hide();
end

function Lua_UnlockPrimaryWarWindow:dispose()
	if self.contentTxt ~= nil then
		self.contentTxt:dispose();
		self.contentTxt = nil;
	end

	self:superCall("dispose");
end