--冒险之旅 任务完成弹窗
Lua_ExploreTourPopupWindow = class("Lua_ExploreTourPopupWindow", Lua_Window);
function Lua_ExploreTourPopupWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExploreTourPopupWindow";
	self.skinName = "ExploreTourPopupWindow_skin";
	self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
	self.isFullSizeWin = true;
end

function Lua_ExploreTourPopupWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isTrans = false;
	self:resetTimer();

	self.bg:addClickFuntion(self, self.onBgClick);
end

function Lua_ExploreTourPopupWindow:dispose()
	self:removeTimer(self, self.onTransition);
	self:removeTimer(self, self.onChangeTask);
	DataCenter.taskData:showPopupData();
	
	self:superCall("dispose");
end

function Lua_ExploreTourPopupWindow:resetTimer()
	if self.isTrans == false then
		self:removeTimer(self, self.onTransition);

		self:onTransition();
		self:addTimer("onTransition", 2.5, self, self.onTransition);
	end
end

function Lua_ExploreTourPopupWindow:onTransition()
	if self.isTrans == false then
		self.isTrans = true;

		self.showObj:SetActive(false);
		self:addTimer("onChangeTask", 0.5, self, self.onChangeTask);
	end
end

function Lua_ExploreTourPopupWindow:onChangeTask()
	self:removeTimer(self, self.onChangeTask);
	self.isTrans = false;

	local taskVo = DataCenter.taskData.getPopupTaskVo;
	if taskVo ~= nil then
		self.titleTxt.text = taskVo.title;
		self.contentTxt.text = taskVo.description;
		self.showObj:SetActive(true);
	else
		self:hide();
	end
end

function Lua_ExploreTourPopupWindow:onBgClick()
	self:resetTimer();
	Lua_WindowUtil.openWin("Lua_ExploreTourWindow", Lua_WinParam.ACTION_OPEN);
end