--冒险之旅 神器解锁界面
Lua_ExploreTourUnlockWindow = class("Lua_ExploreTourUnlockWindow", Lua_Window);
function Lua_ExploreTourUnlockWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.01;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = 120;

	self.windowName = "Lua_ExploreTourUnlockWindow";
	self.skinName = "ExploreTourUnlockWindow_skin";
end

function Lua_ExploreTourUnlockWindow:buildShowItem()
	self:superCall("buildShowItem");

	LuaUtil.setSceneDataExtendVal("FurEffShow", true);

	self.closeText.anchorValue = 7;

	self._bottomY = 171; -- 最低端
	self._dis = 45; -- 背景底部->具体内容底部   具体内容顶部->标题
	self._bgHeight = 57; -- 标题距离背景顶部的距离
end

function Lua_ExploreTourUnlockWindow:showWin(param)
	self:superCall("showWin", param);

	local artifactId;
	if type(param) == "table" then
		artifactId = param.artifactId;
		if param.modelScenePanel ~= nil then
			if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
				self.modelScenePanel:dispose();
				self.modelScenePanel = nil;
			end
			
			self.modelScenePanel = param.modelScenePanel
			self.modelScenePanel:setParent(self.content)
			self.modelScenePanel:setRotBgDimensions(720, 720)
			self.modelScenePanel:setRotBgPos(0, 130)
			param.modelScenePanel = nil
		end
	elseif type(param) == "number" then
		artifactId = param;
	end
	if artifactId == nil then return end;

	local artifactVo = DataCenter.artifactUtil:getArtifactVoById(artifactId);
	self.titleTxt.text = artifactVo.name;
	self.contentTxt.text = artifactVo.des;
	self.contentTxt:resetSize();

	local txtHeight = self.contentTxt.height;
	local bgheight = self._dis + txtHeight + self._dis + self._bgHeight;
	self.contentTxt:setLocation(0, self._bottomY + self._dis + txtHeight/2);
	self.titleTxt:setLocation(0, self._bottomY + self._dis + txtHeight + self._dis);
	self.txtBg:setLocation(0, self._bottomY + (bgheight)/2);
	self.txtBg:SetDimensions(720, bgheight);
	self:showModel(artifactVo);
end

function Lua_ExploreTourUnlockWindow:dispose()
	LuaUtil.setSceneDataExtendVal("FurEffShow", false);
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	self:superCall("dispose");
end

function Lua_ExploreTourUnlockWindow:showModel(data)
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end

	if self.uiModelUrl == data.uiModelUrl then
		return
	end
	self.uiModelUrl = data.uiModelUrl
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs)
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs)
	self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController)
	self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true)
	self.modelScenePanel:setModelDir(data.uiModelDir)
end

function Lua_ExploreTourUnlockWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	LuaUtil.setSceneDataExtendVal("FurEffShow", bActive);
end