-- 日常任务功能活跃度抵达某种阶段后的奖励item
Lua_TaskActiveItem = class("Lua_TaskActiveItem", Lua_DisplayObject);
function Lua_TaskActiveItem:ctor(p)
	self:superCall("ctor", p, "TaskActiveItem_skin");
end

function Lua_TaskActiveItem:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon:addClickFuntion(self, self.onShowRewardClick);
	self.effectBoxIcon:setEnable(false);
end

function Lua_TaskActiveItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local activeInfo = DataCenter.taskUtil:getActivePointRewardById(data);
	self.reward = activeInfo.reward;
	self.curType = activeInfo.mainType;
	self.activeTxt.text = activeInfo.active;
end

function Lua_TaskActiveItem:setLastAndPosX(isLast, posX)
	self.isLast = isLast;
	self.rewardPosX = posX;
end

-- 更新活跃度奖励的状态显示
function Lua_TaskActiveItem:updateRewardState()
	local activeInfo = DataCenter.taskUtil:getActivePointRewardById(self.data);
	self.rewardState = activeInfo:getRewardState();
	-- 不可领取
	if self.rewardState == 0 then
		self.boxIcon:setAltas(activeInfo.un_draw[1], activeInfo.un_draw[2]);
		self.boxIcon.alpha = 1;
		self.effectBoxIcon:setEnable(false);
	-- 可领取
	elseif self.rewardState == 1 then -- 改为特效
		self.boxIcon:setAltas(activeInfo.can_draw[1], activeInfo.can_draw[2]);
		self.boxIcon.alpha = 0.01;
		self.effectBoxIcon:setAltas(activeInfo.can_frame[1], activeInfo.can_frame[2]);
		self.effectBoxIcon:setEnable(false);
	-- 已领取
	else
		self.boxIcon:setAltas(activeInfo.has_draw[1], activeInfo.has_draw[2]);
		self.boxIcon.alpha = 1;
		self.effectBoxIcon:setAltas(activeInfo.has_frame[1], activeInfo.has_frame[2]);
		self.effectBoxIcon:setEnable(true);
	end

	if self.rewardState == 1 then
		self:showBoxEffect(true, activeInfo.can_drwa_effect);
	end
end

function Lua_TaskActiveItem:showBoxEffect(isShow, effectName)
	if isShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.uiEffect:setUrl(url, effectName);
		end
		self.uiEffect:setEnable(false);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_TaskActiveItem:onShowRewardClick()
	if self.rewardState ~= 1 then
		local param = {isLast = self.isLast, rewardPosX = self.rewardPosX, reward = self.reward};
		Lua_WindowUtil.openWin("Lua_TaskActiveRewardWindow", Lua_WinParam.ACTION_OPEN, param);
	else
		self:showBoxEffect(true, "ui_ty_xbx_0101_6");
		Lua_ProxyManager.getProxy("Lua_TaskProxy"):sReceiveTaskReward(self.curType, self.data);
	end
end

function Lua_TaskActiveItem:dispose()
	self:superCall("dispose");
end