-- 日常任务功能任务item
Lua_TaskRewardItem = class("Lua_TaskRewardItem", Lua_ListCell);
function Lua_TaskRewardItem:ctor(p)
	self:superCall("ctor", p, "TaskItem_skin");
end

function Lua_TaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsTxt:setEnable(false);

	self.rewardIcons = Lua_ItemIconList.new(self.content);
	self.rewardIcons.scaleVal = 0.7;
	self.rewardIcons:setLayout(129, 0, 10);
	self.rewardIcons:setLocation(60, -5, 0);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_TaskRewardItem:setData(data)
	if data == nil then
		return;
	end

	local taskInfo = DataCenter.taskUtil:getTaskInfoById(data);
	self.data = data;
	self.eventId = taskInfo.eventId;
	self.curType = taskInfo.mainType;
	self.explainTxt.text = taskInfo.desc;

	local openState = taskInfo.isOpen;
	if openState then
		self.completeTxt.text = taskInfo:getProgressText();--"<color=#459252>" .. data.curProgress .. "</color>/" .. data.value;
		self.completeProgressBar:setMaxValue(taskInfo.progressMaxValue);
		self.completeProgressBar:setValue(taskInfo:getProgress());

		self.receivedSp:setAltas("common_altas_1", "ui_common_label_17");
	else
		self.tipsTxt.text = taskInfo.advanceMessage;--DataCenter.funcOpenUtil:getFuncOpenVoById(data.openId).advanceMessage;
		self.receivedSp:setAltas("common_altas_2", "ui_common_label_28");
	end
	self.receivedSp:resetSize();

	-- self.receiveStage  0：未完成 1：完成 2：已领取
	self.receiveStage = taskInfo:getReceiveStage();
	if self.receiveStage == 0 then
		self.stateBtn:setStyle(3);
		self.stateBtn:setLangValue(202800);
	elseif self.receiveStage == 1 then
		self.stateBtn:setStyle(1);
		self.stateBtn:setLangValue(202801);
	end
	self.rewardIcons:setArrayData(taskInfo.reward);

	self.tipsTxt:setEnable(not openState);
	self.completeTxt:setEnable(openState);
	self.completeProgressBar:setEnable(openState);
	self.stateBtn:setEnable(openState and self.receiveStage ~= 2);
	self.receivedSp:setEnable(not openState or self.receiveStage == 2);
	self:showRedDot(self.receiveStage == 1);
end

function Lua_TaskRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick(nil);
	end
end

function Lua_TaskRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.rewardIcons.mainContent);
	local showArr = self.rewardIcons.showArr;
	for i = 1, showArr:getSize() do
		if showArr[i].isActive and showArr[i]:checkInBound(winPos.x, winPos.y) then
			return showArr[i];
		end
	end
	return nil;
end

function Lua_TaskRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.6, 0.6);
	end
end

function Lua_TaskRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.7, 0.7);
	end
end

function Lua_TaskRewardItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(282, 10, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TaskRewardItem:onBtnClick(go)
	-- self.receiveStage  0：未完成 1：完成 2：已领取
	if self.receiveStage == 0 then
		if self.eventId ~= nil then
			DataCenter.funcPathUtil:gotoFunction(self.eventId, true)
		end
	elseif self.receiveStage == 1 then
		local time = getTime();
		local deltaTime = time - DataCenter.taskData.lastReceivedTime;
		if deltaTime > DataCenter.taskData.receiveDeltaTime then
			DataCenter.taskData.lastReceivedTime = time;
			local activePoint = DataCenter.taskData:getDailyTaskPanelCurProcessValue();
			DataCenter.taskData:recordActivePointBeforeChanging(self.curType, activePoint);
			Lua_ProxyManager.getProxy("Lua_TaskProxy"):sCompleteTask(self.curType, self.data);
		else
			OperateAlert.showLangValue(202810);
		end
	end
end

function Lua_TaskRewardItem:dispose()
	if self.rewardIcons ~= nil then
		self.rewardIcons:dispose();
		self.rewardIcons = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self.pressItem = nil;

	self:superCall("dispose");
end